﻿
Option Strict Off
Option Explicit On

Public Class Form1
Public Title As String = "Force on a slug"
    ' File handling.
    Public Filewriter As System.IO.StreamWriter
    Public Filereader As System.IO.StreamReader
    Public FieldTextFileName As String = "C:\VBA\MasterCoil\FieldTextFile.txt" 'automaticly generated
    Public FieldPlotFileName As String = "C:\VBA\MasterCoil\FieldPlotFile.xlsx" 'Save an empty excel file with this name, and call sheet "sheet 1", in the correct filestructure
    Public ForceComponentPlotFileName As String = "C:\VBA\MasterCoil\ForceComponentPlotFile.xlsx" 'Save an empty excel file with this name, and call sheet "sheet 1", in the correct filestructure
    Public ForceOnThinDiskPlotFileName As String = "C:\VBA\MasterCoil\ForceOnThinDiskPlotFile.xlsx" 'Save an empty excel file with this name, and call sheet "sheet 1", in the correct filestructure
    Public ForceOnSlugPlotFileName As String = "C:\VBA\MasterCoil\ForceOnSlugPlotFile.xlsx" 'Save an empty excel file with this name, and call sheet "sheet 1", in the correct filestructure
    ' Six key summations are two field components and four derivatives.
    ' First dimension is 201 different values of the axial distance z.
    ' Second dimension is 201 different values of the radial distance r.
    Public Br(200, 200) As Double
    Public Bz(200, 200) As Double
    Public dBrdr(200, 200) As Double
    Public dBrdz(200, 200) As Double
    Public dBzdr(200, 200) As Double
    Public dBzdz(200, 200) As Double
    ' Three terms in the integral.
    ' First dimension is 201 different values of the axial distance z.
    ' Second dimension is 201 different values of the radial distance r.
    Public BzdBzdz(200, 200) As Double
    Public BzdBrdr(200, 200) As Double
    Public BrdBzdr(200, 200) As Double
    Public TotalBxdBxdx(200, 200) As Double ' Sum of the three components
    ' Force on a thin disk and slug.
    ' First dimension is 201 different values of the axial distance z.
    ' Second dimension contains varius disk radii.
    Public ForceOnDisk(200, 10) As Double
    Public ForceOnSlug(200) As Double
    ' Two spatial dimensions z (axial) and r (radial)
    Public Z As Double
    Public R As Double
    Public DelZ As Double
    Public DelR As Double
    ' Properties of the solenoid.
    Public Hcoil As Double = 0.514 ' 51.4 cm = 
    Public Rcore As Double = 0.02 / 2 ' 2 cm =
    Public Nturns As Int32 = 254 ' 
    Public Nlayers As Int32 = 16
    ' For calculations on a grid.
    Dim Zstart As Double = -Hcoil ' Examine Z one coil's length on either side
    Dim Zstop As Double = Hcoil
    Dim Rstart As Double = -0.99 * Rcore ' Examine R 99% of core radius on either side
    Dim Rstop As Double = 0.99 * Rcore
    Dim NumZ As Int32 = 201
    Dim NumR As Int32 = 199
    ' Properties of the slug.
    Public Rslug As Double = 0.019 / 2 ' 1.9cm
    Public Hslug As Double = 0.3 ' 30cm  
    ' Summation variables.
    Public Theta As Double ' Angle around a solenoid turn
    Public CosTheta As Double ' Cosine of Theta
    Public DelTheta As Double ' Differental of Theta
    Public Zprime As Double ' Axial distance z
    Public DelZprime As Double ' Differential of axial distance z
    Public Numerator As Double
    Public Denominator As Double
    Public Denominator1 As Double
    Public Denominator2 As Double
    ' String handlers.
    Public TempString As String
    Public LenString As Int32
    Sub New()
        InitializeComponent()
        With Me
            Size = New System.Drawing.Size(500, 300)
            Controls.Add(TextBox)
            TextBox.BringToFront()
            PerformLayout()
            Show()
            BringToFront()
            Refresh()
        End With
        Execute()
    End Sub
    Public TextBox As New Windows.Forms.TextBox() With _
    {.Size = New System.Drawing.Size(450, 200), _
    .Location = New System.Drawing.Point(25, 10), _
    .Text = "", .TextAlign = HorizontalAlignment.Left, _
    .Multiline = True}
    Sub Execute()
        Dim MsgBoxResult As MsgBoxResult
        MsgBoxResult = MsgBox("Calculate and save fields?", vbYesNo, Title)
        If (MsgBoxResult = vbYes) Then
            MsgBoxResult = MsgBox("Are you sure?", vbYesNo, "Re-calculate field")
            If (MsgBoxResult = vbYes) Then
                CalculateAndSaveFields(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
                Hcoil, Rcore, Nturns, Nlayers, FieldTextFileName)
            End If
        End If
        MsgBoxResult = MsgBox("Create Excel file for field?", vbYesNo, Title)
        If (MsgBoxResult = vbYes) Then
            ReadFieldFile(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, FieldTextFileName)
            SaveFieldFileForPlotting(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, FieldPlotFileName)
        End If
        MsgBoxResult = MsgBox("Create Excel file for force components?", vbYesNo, Title)
        If (MsgBoxResult = vbYes) Then
            ReadFieldFile(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, FieldTextFileName)
            CalculateForceComponents(NumZ, NumR)
            SaveForceComponentFileForPlotting(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, ForceComponentPlotFileName)
        End If
        MsgBoxResult = MsgBox("Create Excel file for force on thin disk?", vbYesNo, Title)
        If (MsgBoxResult = vbYes) Then
            ReadFieldFile(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, FieldTextFileName)
            CalculateForceComponents(NumZ, NumR)
            For I As Int32 = 1 To 4 Step 1
                Select Case I
                    Case 1
                        CalculateForceOnThinDisk(NumZ, NumR, Rstart, Rstop, 0.4 * Rslug, 1)
                    Case 2
                        CalculateForceOnThinDisk(NumZ, NumR, Rstart, Rstop, 0.6 * Rslug, 2)
                    Case 3
                        CalculateForceOnThinDisk(NumZ, NumR, Rstart, Rstop, 0.8 * Rslug, 3)
                    Case 4
                        CalculateForceOnThinDisk(NumZ, NumR, Rstart, Rstop, Rslug, 4)
                    Case Else
                        MsgBox("Unrecognized disk radius")
                        Application.Exit()
                End Select
            Next I
            SaveForceOnThinDiskFileForPlotting(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, 4, ForceOnThinDiskPlotFileName)
        End If
        MsgBoxResult = MsgBox("Calculate force on slug?", vbYesNo, "Force on slug")
        If (MsgBoxResult = vbYes) Then
            ReadFieldFile(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, FieldTextFileName)
            TextBox.Text = "Now calculating force components"
            Me.Refresh()
            CalculateForceComponents(NumZ, NumR)
            TextBox.Text = "Now calculating forces on a thin disk"
            Me.Refresh()
            CalculateForceOnThinDisk(NumZ, NumR, Rstart, Rstop, Rslug, 1)
            TextBox.Text = "Now calculating forces on a slug"
            Me.Refresh()
            CalculateForceOnSlug(NumZ, NumR, Zstart, Zstop, Rslug, Hslug)
            TextBox.Text = "Now saving forces on a slug"
            SaveForceOnSlugFileForPlotting(NumZ, NumR, Zstart, Zstop, Rstart, Rstop, _
            Hcoil, Rcore, Nturns, Nlayers, Rslug, Hslug, ForceOnSlugPlotFileName)
        End If
        MsgBox("All done")
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' CalculateAndSaveFields() is the principal numerical subroutine. It
    ' calculates the six summations -- the two components of the magnetic field
    ' and the four derivaties -- at NumZ * NumR different grid points.
    '
    ' The grid is NumZ points wide and NumR points high. Where the grid starts
    ' and stops is determined by the arguments Zstart, Zstop, Rstart and Rstop.
    ' The grid points are spaced apart by (Zstop-Zstart)/(NumZ-1) and by
    ' (Rstart-Rstop)/(NumR-1). For all matrices, the Z-component is the first
    ' dimension and the R-component is the second dimension.
    '
    ' The arguments Hcoil and Rcore and passed in as arguments. The number of
    ' turns and layers are passed in as the arguments Nturns and Nlayers.
    ' Note carefully that the wire's diameter is determined as WireD =
    ' Hcoil / Nturns. The user must make sure that all three quantities are
    ' consistent physically.
    '
    ' Traverses around turns of the solenoid are done by dividing the circle
    ' into 2000 segments.
    '
    ' The results do not include the factor: permeability of free space
    ' multiplied by the current and divided by 4pi. Calculation are carried
    ' out in the units supplied. They must be consistent, but need not be SI.
    '
    ' Results are saved in a text file whose complete path name is passed in
    ' as an argument.
    '
    Sub CalculateAndSaveFields( _
    ByVal NumZ As Int32, ByVal NumR As Int32, _
    ByVal Zstart As Double, ByVal Zstop As Double, _
    ByVal Rstart As Double, ByVal Rstop As Double, _
    ByVal Hcoil As Double, ByVal Rcore As Double, _
    ByVal Nturns As Int32, ByVal Nlayers As Int32, _
    ByVal FieldTextFileName As String)
        Dim WireD As Double
        Dim Rlayer As Double
        Dim Zturn As Double
        Dim Numerator0 As Double ' Temporary Rlayer * DelTheta
        Dim Numerator1 As Double ' Temporary Z - Zturn
        Dim Numerator2 As Double ' Temporary (Z - Zturn) * CosTheta
        Dim Numerator3 As Double ' Temporary (R * CosTheta) - Rlayer
        Dim Numerator4 As Double ' Temporary R - (Rlayer * CosTheta)
        Dim Denominator As Double ' Temporary variable
        Dim Denominator1 As Double ' Temporary variable
        Dim Denominator2 As Double ' Temporary variable
        Filewriter = New System.IO.StreamWriter(FieldTextFileName)
        ' Write header information to the text file.
        Filewriter.Write("Zstart= " & Trim(Str(Zstart)) & vbCrLf)
        Filewriter.Write("Zstop= " & Trim(Str(Zstop)) & vbCrLf)
        Filewriter.Write("Rstart= " & Trim(Str(Rstart)) & vbCrLf)
        Filewriter.Write("Rstop= " & Trim(Str(Rstop)) & vbCrLf)
        Filewriter.Write("NumZ= " & Trim(Str(NumZ)) & vbCrLf)
        Filewriter.Write("NumR= " & Trim(Str(NumR)) & vbCrLf)
        Filewriter.Write("Hcoil= " & Trim(Str(Hcoil)) & vbCrLf)
        Filewriter.Write("Rcore= " & Trim(Str(Rcore)) & vbCrLf)
        Filewriter.Write("Nturns= " & Trim(Str(Nturns)) & vbCrLf)
        Filewriter.Write("Nlayers= " & Trim(Str(Nlayers)) & vbCrLf)
        ' Set up constants.
        DelZ = (Zstop - Zstart) / (NumZ - 1)
        DelR = (Rstop - Rstart) / (NumR - 1)
        DelTheta = 2 * Math.PI / 2000
        WireD = Hcoil / Nturns
        ' Loop over grid points in the axial z-direction.
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            Z = Zstart + (Iz * DelZ)
            Filewriter.Write("Iz= " & Trim(Str(Iz)) & " Z= " & Trim(Str(Z)) & vbCrLf)
            ' Loop over grid points in the radial r-direction.
            For Ir As Int32 = 0 To (NumR - 1) Step 1
                R = Rstart + (Ir * DelR)
                ' Initialize the six summations for this grid point.
                Br(Iz, Ir) = 0
                Bz(Iz, Ir) = 0
                dBrdr(Iz, Ir) = 0
                dBrdz(Iz, Ir) = 0
                dBzdr(Iz, Ir) = 0
                dBzdz(Iz, Ir) = 0
                ' Loop over layers in the solenoid.
                For Ilayer As Int32 = 1 To Nlayers Step 1
                    Rlayer = Rcore + ((Ilayer - 0.5) * WireD)
                    Numerator0 = Rlayer * DelTheta
                    ' Loop over the turns in the layer.
                    For Iturn As Int32 = 1 To Nturns Step 1
                        Zturn = -(Hcoil / 2) + ((Iturn - 0.5) * WireD)
                        Numerator1 = Z - Zturn
                        ' Loop over segments around a turn.
                        For Itheta As Int32 = 1 To 2000 Step 1
                            Theta = (Itheta - 0.5) * DelTheta
                            CosTheta = Math.Cos(Theta)
                            Numerator2 = Numerator1 * CosTheta
                            Numerator3 = (R * CosTheta) - Rlayer
                            Numerator4 = R - (Rlayer * CosTheta)
                            Denominator = (R * R) + _
                            (Numerator1 * Numerator1) + _
                            (Rlayer * Rlayer) - _
                            (2 * R * Rlayer * CosTheta)
                            Denominator1 = 1 / (Denominator * Math.Sqrt(Denominator))
                            Denominator2 = Denominator1 / Denominator
                            ' Br
                            Br(Iz, Ir) = Br(Iz, Ir) + _
                            (Numerator0 * Numerator2 * Denominator1)
                            ' Bz
                            Bz(Iz, Ir) = Bz(Iz, Ir) - _
                            (Numerator0 * Numerator3 * Denominator1)
                            ' dBr/dr
                            dBrdr(Iz, Ir) = dBrdr(Iz, Ir) - _
                            (3 * Numerator0 * Numerator2 * Numerator4 * Denominator2)
                            ' dBr/dz
                            dBrdz(Iz, Ir) = dBrdz(Iz, Ir) + _
                            (Numerator0 * CosTheta * Denominator1)
                            dBrdz(Iz, Ir) = dBrdz(Iz, Ir) - _
                            (3 * Numerator0 * Numerator1 * Numerator2 * Denominator2)
                            ' dBz/dr
                            dBzdr(Iz, Ir) = dBzdr(Iz, Ir) - _
                            (Numerator0 * CosTheta * Denominator1)
                            dBzdr(Iz, Ir) = dBzdr(Iz, Ir) + _
                            (3 * Numerator0 * Numerator3 * Numerator4 * Denominator2)
                            ' dBz/dz
                            dBzdz(Iz, Ir) = dBzdz(Iz, Ir) + _
                            (3 * Numerator0 * Numerator1 * Numerator3 * Denominator2)
                        Next Itheta
                    Next Iturn
                Next Ilayer
                ' Display progress to user
                TextBox.Text = "Iz=" & Str(Iz) & " Ir=" & Str(Ir)
                Me.Refresh()
                ' Write the six summations to the text file.
                Filewriter.Write("Ir= " & Trim(Str(Ir)) & " R= " & Trim(Str(R)) & vbCrLf)
                Filewriter.Write("Br= " & Trim(Str(Br(Iz, Ir))) & vbCrLf)
                Filewriter.Write("Bz= " & Trim(Str(Bz(Iz, Ir))) & vbCrLf)
                Filewriter.Write("dBrdr= " & Trim(Str(dBrdr(Iz, Ir))) & vbCrLf)
                Filewriter.Write("dBrdz= " & Trim(Str(dBrdz(Iz, Ir))) & vbCrLf)
                Filewriter.Write("dBzdr= " & Trim(Str(dBzdr(Iz, Ir))) & vbCrLf)
                Filewriter.Write("dBzdz= " & Trim(Str(dBzdz(Iz, Ir))) & vbCrLf)
            Next Ir
        Next Iz
        Filewriter.Close()
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' ReadFieldFile() reads the data from the text file created by the
    ' subroutine CalculateAndSaveFields(). The text file name is passed in
    ' as the argument FieldFileName. All data is saved in the same variables
    ' from whence it originally came and is passed back to the calling routine
    ' as ByRef arguments.
    Sub ReadFieldFile( _
    ByRef NumZ As Int32, ByRef NumR As Int32, _
    ByRef Zstart As Double, ByRef Zstop As Double, _
    ByRef Rstart As Double, ByRef Rstop As Double, _
    ByRef Hcoil As Double, ByRef Rcore As Double, _
    ByRef Nturns As Int32, ByRef Nlayers As Int32, _
    ByVal FieldTextFileName As String)
        Filereader = New System.IO.StreamReader(FieldTextFileName)
        'Filewriter = New System.IO.StreamWriter(FieldPlotFileName)
        'Filewriter.Write("Zstart= " & Trim(Str(Zstart)) & vbCrLf)
        Try
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 7) <> "Zstart=") Then
                MsgBox("Error in line Zstart=")
                Application.Exit()
            Else
                Zstart = Val(Strings.Right(TempString, Len(TempString) - 7))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 6) <> "Zstop=") Then
                MsgBox("Error in line Zstop=")
                Application.Exit()
            Else
                Zstop = Val(Strings.Right(TempString, Len(TempString) - 6))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 7) <> "Rstart=") Then
                MsgBox("Error in line Rstart=")
                Application.Exit()
            Else
                Rstart = Val(Strings.Right(TempString, Len(TempString) - 7))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 6) <> "Rstop=") Then
                MsgBox("Error in line Rstop=")
                Application.Exit()
            Else
                Rstop = Val(Strings.Right(TempString, Len(TempString) - 6))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 5) <> "NumZ=") Then
                MsgBox("Error in line NumZ=")
                Application.Exit()
            Else
                NumZ = CInt(Val(Strings.Right(TempString, Len(TempString) - 5)))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 5) <> "NumR=") Then
                MsgBox("Error in line NumR=")
                Application.Exit()
            Else
                NumR = CInt(Val(Strings.Right(TempString, Len(TempString) - 5)))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 6) <> "Hcoil=") Then
                MsgBox("Error in line Hcoil=")
                Application.Exit()
            Else
                Hcoil = Val(Strings.Right(TempString, Len(TempString) - 6))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 6) <> "Rcore=") Then
                MsgBox("Error in line Rcore=")
                Application.Exit()
            Else
                Rcore = Val(Strings.Right(TempString, Len(TempString) - 6))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 7) <> "Nturns=") Then
                MsgBox("Error in line Nturns=")
                Application.Exit()
            Else
                Nturns = CInt(Val(Strings.Right(TempString, Len(TempString) - 7)))
            End If
            TempString = Filereader.ReadLine()
            If (Strings.Left(TempString, 8) <> "Nlayers=") Then
                MsgBox("Error in line Nlayers=")
                Application.Exit()
            Else
                Nlayers = CInt(Val(Strings.Right(TempString, Len(TempString) - 8)))
            End If
            For Iz = 0 To (NumZ - 1) Step 1
                ' Display progress to user
                TextBox.Text = "Reading Iz=" & Str(Iz)
                Me.Refresh()
                TempString = Filereader.ReadLine()
                If (Strings.Left(TempString, 3) <> "Iz=") Then
                    MsgBox("Expected Iz= and read " & TempString)
                    Application.Exit()
                End If
                TempString = Strings.Right(TempString, Len(TempString) - 3)
                If (Val(TempString) <> Iz) Then
                    MsgBox("Error in line Iz= " & TempString)
                    Application.Exit()
                End If
                For Ir = 0 To (NumR - 1) Step 1
                    TempString = Filereader.ReadLine()
                    If (Strings.Left(TempString, 3) <> "Ir=") Then
                        MsgBox("Expected Ir= and read " & TempString)
                        Application.Exit()
                    End If
                    TempString = Strings.Right(TempString, Len(TempString) - 3)
                    If (Val(TempString) <> Ir) Then
                        MsgBox("Error in line Ir= " & TempString)
                        Application.Exit()
                    End If
                    ' Read Br
                    TempString = Filereader.ReadLine()
                    If (Strings.Left(TempString, 3) <> "Br=") Then
                        MsgBox("Error in Br= when Iz= " & Str(Iz) & _
                        " and Ir= " & Str(Ir))
                        Application.Exit()
                    End If
                    TempString = Strings.Right(TempString, Len(TempString) - 3)
                    Br(Iz, Ir) = Val(TempString)
                    ' Read Bz
                    TempString = Filereader.ReadLine()
                    If (Strings.Left(TempString, 3) <> "Bz=") Then
                        MsgBox("Error in Bz= when Iz= " & Str(Iz) & _
                        " and Ir= " & Str(Ir))
                        Application.Exit()
                    End If
                    TempString = Strings.Right(TempString, Len(TempString) - 3)
                    Bz(Iz, Ir) = Val(TempString)
                    ' Read dBr/dr
                    TempString = Filereader.ReadLine()
                    If (Strings.Left(TempString, 6) <> "dBrdr=") Then
                        MsgBox("Error in dBrdr= when Iz= " & Str(Iz) & _
                        " and Ir= " & Str(Ir))
                        Application.Exit()
                    End If
                    TempString = Strings.Right(TempString, Len(TempString) - 6)
                    dBrdr(Iz, Ir) = Val(TempString)
                    ' Read dBr/dz
                    TempString = Filereader.ReadLine()
                    If (Strings.Left(TempString, 6) <> "dBrdz=") Then
                        MsgBox("Error in dBrdz= when Iz= " & Str(Iz) & _
                        " and Ir= " & Str(Ir))
                        Application.Exit()
                    End If
                    TempString = Strings.Right(TempString, Len(TempString) - 6)
                    dBrdz(Iz, Ir) = Val(TempString)
                    ' Read dBz/dr
                    TempString = Filereader.ReadLine()
                    If (Strings.Left(TempString, 6) <> "dBzdr=") Then
                        MsgBox("Error in dBzdr= when Iz= " & Str(Iz) & _
                        " and Ir= " & Str(Ir))
                        Application.Exit()
                    End If
                    TempString = Strings.Right(TempString, Len(TempString) - 6)
                    dBzdr(Iz, Ir) = Val(TempString)
                    ' Read dBz/dz
                    TempString = Filereader.ReadLine()
                    If (Strings.Left(TempString, 6) <> "dBzdz=") Then
                        MsgBox("Error in dBzdz= when Iz= " & Str(Iz) & _
                        " and Ir= " & Str(Ir))
                        Application.Exit()
                    End If
                    TempString = Strings.Right(TempString, Len(TempString) - 6)
                    dBzdz(Iz, Ir) = Val(TempString)
                Next Ir
            Next Iz
            Filereader.Close()
        Catch e As Exception
            MsgBox("Error reading field file")
            Application.Exit()
        End Try
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' SaveFieldFileForPlotting() saves the six summations -- the two magnetic
    ' field components and the four derivatives -- in an Excel file for
    ' plotting purposes. The complete path name of the Excel file is passed
    ' in as an argument. Do not forget that all variables must exist before
    ' calling this subroutine.
    Sub SaveFieldFileForPlotting( _
    ByVal NumZ As Int32, ByVal NumR As Int32, _
    ByVal Zstart As Double, ByVal Zstop As Double, _
    ByVal Rstart As Double, ByVal Rstop As Double, _
    ByVal Hcoil As Double, ByVal Rcore As Double, _
    ByVal Nturns As Int32, ByVal Nlayers As Int32, _
    ByVal FieldPlotFileName As String)
        Dim objExcel As Microsoft.Office.Interop.Excel.Application
        Dim objExcelWB As Microsoft.Office.Interop.Excel.Workbook
        Dim objExcelWS As Microsoft.Office.Interop.Excel.Worksheet
        Dim WireD As Double
        Dim DelZ As Double
        Dim DelR As Double
        Dim RowNum As Int32
        Dim TempNum As Double
        ' Open Excel file.
        Try
            'Filewriter = New System.IO.StreamWriter(FieldTextFileName2)
            'Filewriter.Write("lol")
            objExcel = CType(CreateObject("Excel.Application"),  _
            Microsoft.Office.Interop.Excel.Application)
            objExcel.Visible = False
            objExcelWB = CType(objExcel.Workbooks.Open(FieldPlotFileName),  _
            Microsoft.Office.Interop.Excel.Workbook)
            objExcelWS = CType(objExcelWB.Sheets("Sheet1"),  _
            Microsoft.Office.Interop.Excel.Worksheet)
        Catch ex As Exception
            Cursor.Current = Cursors.Default
            MsgBox("Could not open the Excel file.", vbOKOnly)
            Application.Exit()
        End Try
        ' Write header information into Excel file.
        objExcelWS.Cells(1, 1) = "Magnetic field data from VB program"
        objExcelWS.Cells(2, 1) = "Zstart="
        objExcelWS.Cells(2, 2) = Trim(Str(Zstart))
        objExcelWS.Cells(3, 1) = "Zstop="
        objExcelWS.Cells(3, 2) = Trim(Str(Zstop))
        objExcelWS.Cells(4, 1) = "NumZ="
        objExcelWS.Cells(4, 2) = Trim(Str(NumZ))
        objExcelWS.Cells(5, 1) = "Rstart="
        objExcelWS.Cells(5, 2) = Trim(Str(Rstart))
        objExcelWS.Cells(6, 1) = "Rstop="
        objExcelWS.Cells(6, 2) = Trim(Str(Rstop))
        objExcelWS.Cells(7, 1) = "NumR="
        objExcelWS.Cells(7, 2) = Trim(Str(NumR))
        objExcelWS.Cells(8, 1) = "Hcoil="
        objExcelWS.Cells(8, 2) = Trim(Str(Hcoil))
        objExcelWS.Cells(9, 1) = "Rcore="
        objExcelWS.Cells(9, 2) = Trim(Str(Rcore))
        objExcelWS.Cells(10, 1) = "Nturns="
        objExcelWS.Cells(10, 2) = Trim(Str(Nturns))
        objExcelWS.Cells(11, 1) = "Nlayers="
        objExcelWS.Cells(11, 2) = Trim(Str(Nlayers))
        WireD = Hcoil / Nturns
        objExcelWS.Cells(12, 1) = "WireD="
        objExcelWS.Cells(12, 2) = Trim(Str(WireD))
        DelZ = (Zstop - Zstart) / (NumZ - 1)
        objExcelWS.Cells(13, 1) = "DelZ="
        objExcelWS.Cells(13, 2) = Trim(Str(DelZ))
        DelR = (Rstop - Rstart) / (NumR - 1)
        objExcelWS.Cells(13, 1) = "DelR="
        objExcelWS.Cells(13, 2) = Trim(Str(DelR))
        ' Write z-co-ordinates across the page.
        RowNum = 15
        objExcelWS.Cells(RowNum, 1) = "Iz="
        objExcelWS.Cells(RowNum + 1, 1) = "Z="
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(Iz))
            TempNum = Zstart + (Iz * DelZ)
            objExcelWS.Cells(RowNum + 1, 5 + Iz) = Trim(Str(TempNum))
        Next Iz
        ' Write block of Br data.
        RowNum = RowNum + 3
        objExcelWS.Cells(RowNum, 1) = "***** Field component Br *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            TextBox.Text = "Writing Br data for Ir=" & Str(Ir) ' Display progress to user
            Me.Refresh()
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(Br(Iz, Ir)))
            Next Iz
        Next Ir
        ' Write block of Bz data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Field component Bz *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            TextBox.Text = "Writing Bz data for Ir=" & Str(Ir) ' Display progress to user
            Me.Refresh()
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(Bz(Iz, Ir)))
            Next Iz
        Next Ir
        ' Write block of dBr/dr data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Derivative dBr/dr *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            TextBox.Text = "Writing dBr/dr data for Ir=" & Str(Ir) ' Display progress
            Me.Refresh()
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(dBrdr(Iz, Ir)))
            Next Iz
        Next Ir
        ' Write block of dBr/dz data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Derivative dBr/dz *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            TextBox.Text = "Writing dBr/dz data for Ir=" & Str(Ir) ' Display progress
            Me.Refresh()
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(dBrdz(Iz, Ir)))
            Next Iz
        Next Ir
        ' Write block of dBz/dr data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Derivative dBz/dr *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            TextBox.Text = "Writing dBz/dr data for Ir=" & Str(Ir) ' Display progress
            Me.Refresh()
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(dBzdr(Iz, Ir)))
            Next Iz
        Next Ir
        ' Write block of dBz/dz data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Derivative dBz/dz *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            TextBox.Text = "Writing dBz/dz data for Ir=" & Str(Ir) ' Display progress
            Me.Refresh()
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(dBzdz(Iz, Ir)))
            Next Iz
        Next Ir
        objExcelWB.Save()
        objExcelWB.Close()
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' CalculateForceComponents() calculates the three axial terms of the
    ' force at each grid point where the two magnetic field components and
    ' the four derivatives are known. Do not forget that all variables must
    ' exist before calling this subroutine.
    Sub CalculateForceComponents( _
    ByVal NumZ As Int32, ByVal NumR As Int32)
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            For Ir As Int32 = 0 To (NumR - 1) Step 1
                BzdBzdz(Iz, Ir) = Bz(Iz, Ir) * dBzdz(Iz, Ir)
                BrdBzdr(Iz, Ir) = Br(Iz, Ir) * dBzdr(Iz, Ir)
                BzdBrdr(Iz, Ir) = Bz(Iz, Ir) * dBrdr(Iz, Ir)
                TotalBxdBxdx(Iz, Ir) = BzdBzdz(Iz, Ir) + BrdBzdr(Iz, Ir) + BzdBrdr(Iz, Ir)
            Next Ir
        Next Iz
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' SaveForceComponentFileForPlotting() saves the three axial terms of the
    ' force in an Excel file for plotting purposes. The complete path name of
    ' the Excel file is passed in as an argument. Do not forget that all
    ' variables must exist before calling this subroutine.
    Sub SaveForceComponentFileForPlotting( _
    ByVal NumZ As Int32, ByVal NumR As Int32, _
    ByVal Zstart As Double, ByVal Zstop As Double, _
    ByVal Rstart As Double, ByVal Rstop As Double, _
    ByVal Hcoil As Double, ByVal Rcore As Double, _
    ByVal Nturns As Int32, ByVal Nlayers As Int32, _
    ByVal ForceComponentPlotFileName As String)
        Dim objExcel As Microsoft.Office.Interop.Excel.Application
        Dim objExcelWB As Microsoft.Office.Interop.Excel.Workbook
        Dim objExcelWS As Microsoft.Office.Interop.Excel.Worksheet
        Dim WireD As Double
        Dim DelZ As Double
        Dim DelR As Double
        Dim RowNum As Int32
        Dim TempNum As Double
        ' Open Excel file.
        Try
            objExcel = CType(CreateObject("Excel.Application"),  _
            Microsoft.Office.Interop.Excel.Application)
            objExcel.Visible = False
            objExcelWB = CType(objExcel.Workbooks.Open(ForceComponentPlotFileName),  _
            Microsoft.Office.Interop.Excel.Workbook)
            objExcelWS = CType(objExcelWB.Sheets("Sheet1"),  _
            Microsoft.Office.Interop.Excel.Worksheet)
        Catch ex As Exception
            Cursor.Current = Cursors.Default
            MsgBox("Could not open the Excel file.", vbOKOnly)
            Application.Exit()
        End Try
        ' Write header information into Excel file.
        objExcelWS.Cells(1, 1) = "Force axial component data from VB program"
        objExcelWS.Cells(2, 1) = "Zstart="
        objExcelWS.Cells(2, 2) = Trim(Str(Zstart))
        objExcelWS.Cells(3, 1) = "Zstop="
        objExcelWS.Cells(3, 2) = Trim(Str(Zstop))
        objExcelWS.Cells(4, 1) = "NumZ="
        objExcelWS.Cells(4, 2) = Trim(Str(NumZ))
        objExcelWS.Cells(5, 1) = "Rstart="
        objExcelWS.Cells(5, 2) = Trim(Str(Rstart))
        objExcelWS.Cells(6, 1) = "Rstop="
        objExcelWS.Cells(6, 2) = Trim(Str(Rstop))
        objExcelWS.Cells(7, 1) = "NumR="
        objExcelWS.Cells(7, 2) = Trim(Str(NumR))
        objExcelWS.Cells(8, 1) = "Hcoil="
        objExcelWS.Cells(8, 2) = Trim(Str(Hcoil))
        objExcelWS.Cells(9, 1) = "Rcore="
        objExcelWS.Cells(9, 2) = Trim(Str(Rcore))
        objExcelWS.Cells(10, 1) = "Nturns="
        objExcelWS.Cells(10, 2) = Trim(Str(Nturns))
        objExcelWS.Cells(11, 1) = "Nlayers="
        objExcelWS.Cells(11, 2) = Trim(Str(Nlayers))
        WireD = Hcoil / Nturns
        objExcelWS.Cells(12, 1) = "WireD="
        objExcelWS.Cells(12, 2) = Trim(Str(WireD))
        DelZ = (Zstop - Zstart) / (NumZ - 1)
        objExcelWS.Cells(13, 1) = "DelZ="
        objExcelWS.Cells(13, 2) = Trim(Str(DelZ))
        DelR = (Rstop - Rstart) / (NumR - 1)
        objExcelWS.Cells(13, 1) = "DelR="
        objExcelWS.Cells(13, 2) = Trim(Str(DelR))
        ' Write z-co-ordinates across the page.
        RowNum = 15
        objExcelWS.Cells(RowNum, 1) = "Iz="
        objExcelWS.Cells(RowNum + 1, 1) = "Z="
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(Iz))
            TempNum = Zstart + (Iz * DelZ)
            objExcelWS.Cells(RowNum + 1, 5 + Iz) = Trim(Str(TempNum))
        Next Iz
        ' Write block of Bz * dBz/dz data.
        RowNum = RowNum + 3
        objExcelWS.Cells(RowNum, 1) = "***** Force component Bz * dBz/dz *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(BzdBzdz(Iz, Ir)))
                TextBox.Text = "Writing Bz * dBz/dz data for Ir=" & Str(Ir) & _
                " and Iz=" & Str(Iz) ' Display progress to user
                Me.Refresh()
            Next Iz
        Next Ir
        ' Write block of Br * dBz/dr data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Force component Br * dBz/dr *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(BrdBzdr(Iz, Ir)))
                TextBox.Text = "Writing Br * dBz/dr data for Ir=" & Str(Ir) & _
                " and Iz=" & Str(Iz) ' Display progress to user
                Me.Refresh()
            Next Iz
        Next Ir
        ' Write block of Bz * dBr/dr data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Force component Bz * dBr/dr *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(BzdBrdr(Iz, Ir)))
                TextBox.Text = "Writing Bz * dBr/dr data for Ir=" & Str(Ir) & _
                " and Iz=" & Str(Iz) ' Display progress to user
                Me.Refresh()
            Next Iz
        Next Ir
        ' Write block of Total Bx * dBx/dx data.
        RowNum = RowNum + 2
        objExcelWS.Cells(RowNum, 1) = "***** Total force Bx * dBx/dx *****"
        For Ir As Int32 = 0 To (NumR - 1) Step 1
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = "Ir="
            objExcelWS.Cells(RowNum, 2) = Trim(Str(Ir))
            TempNum = Rstart + (Ir * DelR)
            objExcelWS.Cells(RowNum, 3) = "R="
            objExcelWS.Cells(RowNum, 4) = Trim(Str(TempNum))
            For Iz As Int32 = 0 To (NumZ - 1) Step 1
                objExcelWS.Cells(RowNum, 5 + Iz) = Trim(Str(TotalBxdBxdx(Iz, Ir)))
                TextBox.Text = "Writing Total Bx * dBx/dx data for Ir=" & Str(Ir) & _
                " and Iz=" & Str(Iz) ' Display progress to user
                Me.Refresh()
            Next Iz
        Next Ir
        objExcelWB.Save()
        objExcelWB.Close()
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' CalculateForceOnThinDisk() calculates the force acting on a thin disk.
    ' The results are saved in ForceOnDisk(*,RadiusIndex), where RadiusIndex
    ' can be up to 10. The first dimension is the axial displacement at the
    ' grid points. Enough radius information needs to be passed to this
    ' subroutine so that it can integrate across the face of the disk.
    ' The integral is carried out in 1000 steps and values of the force
    ' components are interpolated linearly from those at the known grid points.
    ' Do not forget that all variables must exist before calling this
    ' subroutine.
    Sub CalculateForceOnThinDisk( _
    ByVal NumZ As Int32, ByVal NumR As Int32, _
    ByVal Rstart As Double, ByVal Rstop As Double, _
    ByVal Rslug As Double, ByVal RadiusIndex As Int32)
        Dim DelRgrid As Double = (Rstop - Rstart) / (NumR - 1)
        Dim DelRdisk As Double = Rslug / 1000
        Dim IgridLow As Int32 ' Lower bound for interpolation
        Dim IgridHigh As Int32 ' Lower bound for interpolation
        Dim RdiskMid As Double ' Mid-point of radial segment on disk
        Dim IntBzdBzdz As Double ' Interpolated value
        Dim IntBzdBrdr As Double ' Interpolated value
        Dim IntBrdBzdr As Double ' Interpolated value
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            ' Initialize the cumulative total.
            ForceOnDisk(Iz, RadiusIndex) = 0
            For Ir As Int32 = 1 To 1000 Step 1
                RdiskMid = (Ir - 0.5) * DelRdisk
                ' Provisionally calculate the nearest surrounding grid points.
                IgridLow = CInt(RdiskMid / DelRgrid)
                IgridHigh = IgridLow + 1
                ' Ensure that RgridLow is less than or equal to RdiskMid.
                If (IgridLow * DelRgrid > RdiskMid) Then
                    IgridLow = IgridLow - 1
                    IgridHigh = IgridLow + 1
                End If
                ' Ensure that RgridHigh is greater than or equal to RdiskMid.
                If (IgridHigh * DelRgrid < RdiskMid) Then
                    IgridLow = IgridLow - 1
                    IgridHigh = IgridLow + 1
                End If
                ' Interpolate the force components from the surrounding grid points.
                IntBzdBzdz = BzdBzdz(Iz, IgridLow) + _
                ((RdiskMid - (IgridLow * DelRgrid)) * _
                (BzdBzdz(Iz, IgridHigh) - BzdBzdz(Iz, IgridLow)) / DelRgrid)
                IntBzdBrdr = BzdBrdr(Iz, IgridLow) + _
                ((RdiskMid - (IgridLow * DelRgrid)) * _
                (BzdBrdr(Iz, IgridHigh) - BzdBrdr(Iz, IgridLow)) / DelRgrid)
                IntBrdBzdr = BrdBzdr(Iz, IgridLow) + _
                ((RdiskMid - (IgridLow * DelRgrid)) * _
                (BrdBzdr(Iz, IgridHigh) - BrdBzdr(Iz, IgridLow)) / DelRgrid)
                ' Add the increment to the integral.
                ForceOnDisk(Iz, RadiusIndex) = ForceOnDisk(Iz, RadiusIndex) + _
                (RdiskMid * IntBzdBzdz * DelRdisk) + _
                (RdiskMid * IntBzdBrdr * DelRdisk) + _
                (RdiskMid * IntBrdBzdr * DelRdisk)
            Next Ir
        Next Iz
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' SaveForceOnThinDiskFileForPlotting() saves the force on a thin disk in
    ' an Excel file for plotting purposes. The complete path name of the
    ' Excel file is passed in as an argument. Do not forget that all
    ' variables must exist before calling this subroutine.
    Sub SaveForceOnThinDiskFileForPlotting( _
    ByVal NumZ As Int32, ByVal NumR As Int32, _
    ByVal Zstart As Double, ByVal Zstop As Double, _
    ByVal Rstart As Double, ByVal Rstop As Double, _
    ByVal Hcoil As Double, ByVal Rcore As Double, _
    ByVal Nturns As Int32, ByVal Nlayers As Int32, _
    ByVal MaxRadiusIndex As Int32, _
    ByVal ForceOnThinDiskPlotFileName As String)
        Dim objExcel As Microsoft.Office.Interop.Excel.Application
        Dim objExcelWB As Microsoft.Office.Interop.Excel.Workbook
        Dim objExcelWS As Microsoft.Office.Interop.Excel.Worksheet
        Dim WireD As Double
        Dim DelZ As Double
        Dim DelR As Double
        Dim RowNum As Int32
        Dim TempNum As Double
        ' Open Excel file.
        Try
            objExcel = CType(CreateObject("Excel.Application"),  _
            Microsoft.Office.Interop.Excel.Application)
            objExcel.Visible = False
            objExcelWB = CType(objExcel.Workbooks.Open(ForceOnThinDiskPlotFileName),  _
            Microsoft.Office.Interop.Excel.Workbook)
            objExcelWS = CType(objExcelWB.Sheets("Sheet1"),  _
            Microsoft.Office.Interop.Excel.Worksheet)
        Catch ex As Exception
            Cursor.Current = Cursors.Default
            MsgBox("Could not open the Excel file.", vbOKOnly)
            Application.Exit()
        End Try
        ' Write header information into Excel file.
        objExcelWS.Cells(1, 1) = "Force on thin disk from VB program"
        objExcelWS.Cells(2, 1) = "Zstart="
        objExcelWS.Cells(2, 2) = Trim(Str(Zstart))
        objExcelWS.Cells(3, 1) = "Zstop="
        objExcelWS.Cells(3, 2) = Trim(Str(Zstop))
        objExcelWS.Cells(4, 1) = "NumZ="
        objExcelWS.Cells(4, 2) = Trim(Str(NumZ))
        objExcelWS.Cells(5, 1) = "Rstart="
        objExcelWS.Cells(5, 2) = Trim(Str(Rstart))
        objExcelWS.Cells(6, 1) = "Rstop="
        objExcelWS.Cells(6, 2) = Trim(Str(Rstop))
        objExcelWS.Cells(7, 1) = "NumR="
        objExcelWS.Cells(7, 2) = Trim(Str(NumR))
        objExcelWS.Cells(8, 1) = "Hcoil="
        objExcelWS.Cells(8, 2) = Trim(Str(Hcoil))
        objExcelWS.Cells(9, 1) = "Rcore="
        objExcelWS.Cells(9, 2) = Trim(Str(Rcore))
        objExcelWS.Cells(10, 1) = "Nturns="
        objExcelWS.Cells(10, 2) = Trim(Str(Nturns))
        objExcelWS.Cells(11, 1) = "Nlayers="
        objExcelWS.Cells(11, 2) = Trim(Str(Nlayers))
        WireD = Hcoil / Nturns
        objExcelWS.Cells(12, 1) = "WireD="
        objExcelWS.Cells(12, 2) = Trim(Str(WireD))
        DelZ = (Zstop - Zstart) / (NumZ - 1)
        objExcelWS.Cells(13, 1) = "DelZ="
        objExcelWS.Cells(13, 2) = Trim(Str(DelZ))
        DelR = (Rstop - Rstart) / (NumR - 1)
        objExcelWS.Cells(13, 1) = "DelR="
        objExcelWS.Cells(13, 2) = Trim(Str(DelR))
        ' Write headers across the page.
        objExcelWS.Cells(17, 1) = "Iz"
        objExcelWS.Cells(17, 2) = "Z"
        For RadiusIndex As Int32 = 1 To MaxRadiusIndex Step 1
            objExcelWS.Cells(15, 2 + RadiusIndex) = "Radius"
            objExcelWS.Cells(16, 2 + RadiusIndex) = "Index"
            objExcelWS.Cells(17, 2 + RadiusIndex) = "# " & Trim(Str(RadiusIndex))
        Next RadiusIndex
        ' Write the ForceOnDisk data.
        RowNum = 18
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = Trim(Str(Iz))
            TempNum = Zstart + (Iz * DelZ)
            objExcelWS.Cells(RowNum, 2) = Trim(Str(TempNum))
            For RadiusIndex As Int32 = 1 To MaxRadiusIndex Step 1
                objExcelWS.Cells(RowNum, 2 + RadiusIndex) = _
                Trim(Str(ForceOnDisk(Iz, RadiusIndex)))
            Next RadiusIndex
        Next Iz
        objExcelWB.Save()
        objExcelWB.Close()
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' CalculateForceOnSlug() calculates the force acting on a slug. The
    ' results are saved in ForceOnSlug(), where the dimension is the axial
    ' displacement of the geometric center of the slug. The subroutine does
    ' not calculate the force if any part of the slug lies outside of the grid
    ' at which the magnetic data has been calaculated. In those case, the
    ' entry in ForceOnSlug() is left at zero. The slug is divided axially
    ' into 500 thin disks. Before calling this subroutine, the subroutine
    ' CalculateForceOnThinDisk() must be called and vector ForceonDisk(,1)
    ' loaded at all axial displacements on the grid with the force on a disk
    ' with the same radius as the slug. The values of the force on the thin
    ' at axial displacements which are not on the grid are interpolated
    ' linearly from those at the known grid points. Do not forget that all
    ' variables must exist before calling this subroutine.
    Sub CalculateForceOnSlug( _
    ByVal NumZ As Int32, ByVal NumR As Int32, _
    ByVal Zstart As Double, ByVal Zstop As Double, _
    ByVal Rslug As Double, ByVal Hslug As Double)
        Dim DelZgrid As Double = (Zstop - Zstart) / (NumZ - 1)
        Dim IgridLow As Int32 ' Lower bound for interpolation
        Dim IgridHigh As Int32 ' Lower bound for interpolation
        Dim ZslugMid As Double ' Axial mid-point of the slug
        Dim ZslugMax As Double ' Axial displacement of positive face of the slug
        Dim ZslugMin As Double ' Axial displacement of negative face of the slug
        Dim ZdiskMid As Double ' Axial mid-point of a thin disk in the slug
        Dim IntForceOnDisk As Double ' Interpolated value of force on a thin disk
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            ZslugMid = Iz * DelZgrid
            ZslugMax = ZslugMid + (0.5 * Hslug)
            ZslugMin = ZslugMid - (0.5 * Hslug)
            Do
                ' Do not calculate if the negative end of the slug is outside the grid.
                If (ZslugMin < 0) Then
                    ForceOnSlug(Iz) = 0
                    Exit Do
                End If
                ' Do not calculate if the positive end of the slug is outside the grid.
                If (ZslugMax > ((NumZ - 1) * DelZgrid)) Then
                    ForceOnSlug(Iz) = 0
                    Exit Do
                End If
                ' Initialize the cumulative total.
                ForceOnSlug(Iz) = 0
                For Idisk As Int32 = 1 To 500 Step 1
                    ZdiskMid = ZslugMin + (Idisk - 0.5) * Hslug / 500
                    ' Provisionally calculate the nearest surrounding grid points.
                    IgridLow = CInt(ZdiskMid / DelZgrid)
                    IgridHigh = IgridLow + 1
                    ' Ensure that ZgridLow is less than or equal to ZdiskMid.
                    If (IgridLow * DelZgrid > ZdiskMid) Then
                        IgridLow = IgridLow - 1
                        IgridHigh = IgridLow + 1
                    End If
                    ' Ensure that ZgridHigh is greater than or equal to ZdiskMid.
                    If (IgridHigh * DelZgrid < ZdiskMid) Then
                        IgridLow = IgridLow - 1
                        IgridHigh = IgridLow + 1
                    End If
                    ' Interpolate the force components from the surrounding grid points.
                    IntForceOnDisk = ForceOnDisk(IgridLow, 1) + _
                    ((ZdiskMid - (IgridLow * DelZgrid)) * _
                    (ForceOnDisk(IgridHigh, 1) - ForceOnDisk(IgridLow, 1)) / DelZgrid)
                    ' Add the increment to the integral.
                    ForceOnSlug(Iz) = ForceOnSlug(Iz) + (IntForceOnDisk * Hslug / 500)
                Next Idisk
                Exit Do
            Loop
            ' Display progress to user.
            TextBox.Text = "Calculating force at Iz = " & Trim(Str(Iz))
            Me.Refresh()
        Next Iz
    End Sub
    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////
    ' SaveForceOnSlugForPlotting() saves the force on a slug in an Excel file
    ' for plotting purposes. The complete path name of the Excel file is
    ' passed in as an argument. Do not forget that all variables must exist
    ' before calling this subroutine.
    Sub SaveForceOnSlugFileForPlotting( _
    ByVal NumZ As Int32, ByVal NumR As Int32, _
    ByVal Zstart As Double, ByVal Zstop As Double, _
    ByVal Rstart As Double, ByVal Rstop As Double, _
    ByVal Hcoil As Double, ByVal Rcore As Double, _
    ByVal Nturns As Int32, ByVal Nlayers As Int32, _
    ByVal Rslug As Double, ByVal Hslug As Double, _
    ByVal ForceOnSlugPlotFileName As String)
        Dim objExcel As Microsoft.Office.Interop.Excel.Application
        Dim objExcelWB As Microsoft.Office.Interop.Excel.Workbook
        Dim objExcelWS As Microsoft.Office.Interop.Excel.Worksheet
        Dim WireD As Double
        Dim DelZ As Double
        Dim DelR As Double
        Dim RowNum As Int32
        Dim TempNum As Double
        ' Open Excel file.
        Try
            objExcel = CType(CreateObject("Excel.Application"),  _
            Microsoft.Office.Interop.Excel.Application)
            objExcel.Visible = False
            objExcelWB = CType(objExcel.Workbooks.Open(ForceOnSlugPlotFileName),  _
            Microsoft.Office.Interop.Excel.Workbook)
            objExcelWS = CType(objExcelWB.Sheets("Sheet1"),  _
            Microsoft.Office.Interop.Excel.Worksheet)
        Catch ex As Exception
            Cursor.Current = Cursors.Default
            MsgBox("Could not open the Excel file.", vbOKOnly)
            Application.Exit()
        End Try
        ' Write header information into Excel file.
        objExcelWS.Cells(1, 1) = "Force on slug from Force_On_Steel_Slug VB program"
        objExcelWS.Cells(2, 1) = "Zstart="
        objExcelWS.Cells(2, 2) = Trim(Str(Zstart))
        objExcelWS.Cells(3, 1) = "Zstop="
        objExcelWS.Cells(3, 2) = Trim(Str(Zstop))
        objExcelWS.Cells(4, 1) = "NumZ="
        objExcelWS.Cells(4, 2) = Trim(Str(NumZ))
        objExcelWS.Cells(5, 1) = "Rstart="
        objExcelWS.Cells(5, 2) = Trim(Str(Rstart))
        objExcelWS.Cells(6, 1) = "Rstop="
        objExcelWS.Cells(6, 2) = Trim(Str(Rstop))
        objExcelWS.Cells(7, 1) = "NumR="
        objExcelWS.Cells(7, 2) = Trim(Str(NumR))
        objExcelWS.Cells(8, 1) = "Hcoil="
        objExcelWS.Cells(8, 2) = Trim(Str(Hcoil))
        objExcelWS.Cells(9, 1) = "Rcore="
        objExcelWS.Cells(9, 2) = Trim(Str(Rcore))
        objExcelWS.Cells(10, 1) = "Nturns="
        objExcelWS.Cells(10, 2) = Trim(Str(Nturns))
        objExcelWS.Cells(11, 1) = "Nlayers="
        objExcelWS.Cells(11, 2) = Trim(Str(Nlayers))
        WireD = Hcoil / Nturns
        objExcelWS.Cells(12, 1) = "WireD="
        objExcelWS.Cells(12, 2) = Trim(Str(WireD))
        DelZ = (Zstop - Zstart) / (NumZ - 1)
        objExcelWS.Cells(13, 1) = "DelZ="
        objExcelWS.Cells(13, 2) = Trim(Str(DelZ))
        DelR = (Rstop - Rstart) / (NumR - 1)
        objExcelWS.Cells(13, 1) = "DelR="
        objExcelWS.Cells(13, 2) = Trim(Str(DelR))
        objExcelWS.Cells(14, 1) = "Rslug="
        objExcelWS.Cells(14, 2) = Trim(Str(Rslug))
        objExcelWS.Cells(15, 1) = "Hslug="
        objExcelWS.Cells(15, 2) = Trim(Str(Hslug))
        ' Write headers across the page.
        objExcelWS.Cells(17, 1) = "Iz"
        objExcelWS.Cells(17, 2) = "Z"
        objExcelWS.Cells(17, 3) = "Force"
        ' Write the ForceOnSlug data.
        RowNum = 18
        For Iz As Int32 = 0 To (NumZ - 1) Step 1
            RowNum = RowNum + 1
            objExcelWS.Cells(RowNum, 1) = Trim(Str(Iz))
            TempNum = Zstart + (Iz * DelZ)
            objExcelWS.Cells(RowNum, 2) = Trim(Str(TempNum))
            objExcelWS.Cells(RowNum, 3) = Trim(Str(ForceOnSlug(Iz)))
        Next Iz
        objExcelWB.Save()
        objExcelWB.Close()
    End Sub
End Class
